var phidget22 = require('phidget22');

var SERVER_PORT = 5661;

function main() {

	if (process.argv.length != 3) {
		console.log('usage: node Gyroscope.js <server address>');
		process.exit(1);
	}
	var hostname = process.argv[2];

	console.log('connecting to:' + hostname);
	var conn = new phidget22.Connection(SERVER_PORT, hostname, { name: 'Server Connection', passwd: '' });
	conn.connect()
		.then(runExample)
		.catch(function (err) {
			console.error('Error running example:', err.message);
			process.exit(1);
		});
}

function runExample() {

	console.log('connected to server');
	var ch = new phidget22.Gyroscope();

	ch.onAttach = function (ch) {
		console.log(ch + ' attached');
		console.log('Min Angular Rate: ' + ch.getMinAngularRate());
		console.log('Max Angular Rate: ' + ch.getMaxAngularRate());
		ch.zero();
	};

	ch.onDetach = function (ch) {
		console.log(ch + ' detached');
	};

	ch.onAngularRateUpdate = function (angularRate, timestamp) {
		var ggyro = this.getAngularRate();
		console.log('ang rate x:' + angularRate[0] + ' (' + ggyro[0] + ')' +
			' y:' + angularRate[1] + '(' + ggyro[1] + ') z:' + angularRate[2] + ' (' + ggyro[2] + ')');
		console.log('timestamp: ' + timestamp);
		console.log('');
	};

	ch.open().then(function (ch) {
		console.log('channel open');
	}).catch(function (err) {
		console.log('failed to open the channel:' + err);
	});
}

if (require.main === module)
	main();
